//
//  ViewController.swift
//  Bsp06_Alert
//
//  Created by User1 on 28.09.22.
//

import UIKit

class ViewController: UIViewController {
      // Referenz
    
    @IBOutlet var editor: UITextView!
    // Events
    @IBAction func bnOk_Click(_ sender: UIButton) {
        editor.text="ok"
        showOkDialog("Info Meldung", "Ihre Festplatte wurde gelöscht!")
    }
    
    @IBAction func bnOkCancel_Click(_ sender: UIButton) {
        editor.text="okCancel"
        showOkCancelDialog("Info Meldung", "Soll Ihre Festplatte gelöscht werden!")
    }
    
    @IBAction func bnYesNo_Click(_ sender: UIButton) {
        editor.text="YesNo"
        showYesNoDialog("Info Meldung", "Soll Ihre Festplatte gelöscht werden!")
    }
    @IBAction func bnYesNoPointer1(_ sender: UIButton) {
        editor.text="YesNoP1"
        showYesNoPointer1Dialog("Info Meldung",
                                "Soll Ihre Festplatte gelöscht werden!", _yesFunc: yesPointer1, _noFunc: noPointer1)
    }
    
    func yesPointer1() {
        editor.text="YesPointer1 wurde gedrückt (YesNoPointer1Dialog)"
    }
    func noPointer1() {
        editor.text="NoPointer1 wurde gedrückt (YesNoPointer1Dialog)"
    }
    func cancelPointer1() {
        editor.text="cancelPointer1 wurde gedrückt (YesNoCancelPointer1Dialog)"
    }
    func yesPointer2() {
        editor.text="YesPointer2 wurde gedrückt (YesNoPointer2Dialog)"
    }
    func noPointer2() {
        editor.text="NoPointer2 wurde gedrückt (YesNoPointer2Dialog)"
        
    }
    
    @IBAction func bnYesNoPointer2(_ sender: UIButton) {
        editor.text="YesNoP2"
        editor.backgroundColor = UIColor.yellow
        showYesNoPointer1Dialog("Info Meldung",
                                "Soll Ihre Festplatte gelöscht werden!", _yesFunc: yesPointer2, _noFunc: noPointer2)
    }
    
    @IBAction func bnYesNoCancelPointer(_ sender: UIButton) {
        editor.text="YesNoCancel"
        showYesNoCancelPointer1Dialog("Info Meldung",
                                "Soll Ihre Festplatte gelöscht werden!", _yesFunc: yesPointer1, _noFunc: noPointer1, _cancelFunc: cancelPointer1)
    }
    @IBAction func bnInput2String_Click(_ sender: UIButton) {
        editor.text="YesNo 2 Strings"
        showInput2StringsDialog("input","eingabe")
    }
    
    func ok() {
        editor.text="Ok wurde gedrückt (okDialog)"
    }
    func cancel() {
        editor.text="Cancel wurde gedrückt (okDialog)"
    }
    func yes() {
        editor.text="Yes wurde gedrückt (YesNoDialog)"
    }
    func no() {
        editor.text="No wurde gedrückt (YesNoDialog)"
    }
    
    func showOkDialog(_ title:String,_ message:String) {
        let alertController = UIAlertController(title: title,message: message, preferredStyle: .actionSheet)  // .alert
        let okAction = UIAlertAction(title: "ok",style:.default){(_) in
            self.ok()
        }
        
        alertController.addAction(okAction)
        
        self.present(alertController, animated: true, completion:nil)
    }
    
    func showOkCancelDialog(_ title:String,_ message:String) {
        let alertController = UIAlertController(title: title,message: message, preferredStyle: .actionSheet)  // .alert
        let okAction = UIAlertAction(title: "ok",style:.default){(_) in
            self.ok()
        }
        let cancelAction = UIAlertAction(title: "cancel",style:.cancel){(_) in
            self.cancel()
        }
        alertController.addAction(okAction)
        alertController.addAction(cancelAction)
        self.present(alertController, animated: true, completion:nil)
    }
    
    func showYesNoDialog(_ title:String,_ message:String) {
        let alertController = UIAlertController(title: title,message: message, preferredStyle: .alert)  // .alert
        let yesAction = UIAlertAction(title: "yes",style:.default){(_) in
            self.yes()
        }
        let noAction = UIAlertAction(title: "no",style:.cancel){(_) in
            self.no()
        }
        alertController.addAction(yesAction)
        alertController.addAction(noAction)
        self.present(alertController, animated: true, completion:nil)
    }
    
    func showYesNoPointer1Dialog(_ title:String,_ message:String, _yesFunc yesFunction: @escaping()->Void,_noFunc noFunction: @escaping()->Void) {
        let alertController = UIAlertController(title: title,message: message, preferredStyle: .alert)  // .alert
        let yesAction = UIAlertAction(title: "yes",style:.default){(_) in
            yesFunction()
        }
        let noAction = UIAlertAction(title: "no",style:.cancel){(_) in
            noFunction()
        }
        alertController.addAction(yesAction)
        alertController.addAction(noAction)
        self.present(alertController, animated: true, completion:nil)
    }
    
    func showYesNoCancelPointer1Dialog(_ title:String,_ message:String, _yesFunc yesFunction: @escaping()->Void,_noFunc noFunction: @escaping()->Void,
                                       _cancelFunc cancelFunction: @escaping()->Void) {
        let alertController = UIAlertController(title: title,message: message, preferredStyle: .alert)  // .alert
        let yesAction = UIAlertAction(title: "yes",style:.default){(_) in
            yesFunction()
        }
        let noAction = UIAlertAction(title: "no",style:.cancel){(_) in
            noFunction()
        }
        let cancelAction = UIAlertAction(title: "cancel",style:.destructive){(_) in
            cancelFunction()
        }
        alertController.addAction(yesAction)
        alertController.addAction(noAction)
        alertController.addAction(cancelAction)
        self.present(alertController, animated: true, completion:nil)
    }
    
    func input() {
        
    }
    let textField: UITextField = UITextField()
    
    func showInput2StringsDialog(_ title:String,_ message:String) {
        //Creating UIAlertController and
        //Setting title and message for the alert dialog
        let alertController = UIAlertController(title: "Alert Dialog", message: "Eingaben", preferredStyle: .alert)
        
        //the confirm action taking the inputs
        // der ok-button wird hier erzeugt
        //  er erhält außerdem die textfelder
        let confirmAction = UIAlertAction(title: "Enter", style: .default) { (_) in
            
            //getting the input values from user
            let vorname = alertController.textFields?[0].text
            let nachname = alertController.textFields?[1].text
            let matrnr = alertController.textFields?[2].text
            
            self.editor.text = "vorname: " + vorname! + "\nNachname: " + nachname! + "\nmatrnr: " + matrnr!
            
        }
        
        //the cancel action doing nothing
        let cancelAction = UIAlertAction(title: "Cancel", style: .cancel) { (_) in }
        
        
        //adding textfields to our dialog box
        // die textfields werden automatisch erzeugt (ohne namen)
        // die textfields werden in einem internen Array gespeichert
        alertController.addTextField { (textField) in
            textField.placeholder = "Vorname"
            textField.keyboardAppearance = .light
                           textField.keyboardType = .default
                           textField.autocorrectionType = .default
                           textField.placeholder = "Eingabe des Vornamens"
                           textField.textColor = UIColor.green
        }
        alertController.addTextField { (textField) in
            textField.placeholder = "Nachname"
            textField.keyboardAppearance = .dark
            textField.keyboardType = .namePhonePad
                           textField.autocorrectionType = .default
                           textField.placeholder = "Eingabe des Nachnamens"
                           textField.textColor = UIColor.red
        }

        alertController.addTextField { (textField) in
            textField.placeholder = "Matrikelnummer"
            
                textField.keyboardAppearance = .dark
                textField.keyboardType = .numberPad
                textField.autocorrectionType = .default
                textField.placeholder = "Eingabe der Matrikelnummer (ohne m)"
                textField.textColor = UIColor.blue
            // textField.isSecureTextEntry = true  // password
            textField.font = UIFont(name: "AmericanTypewriter", size: 14)
            
        }
        
        
        
        //adding the action to dialogbox
        alertController.addAction(confirmAction)
        alertController.addAction(cancelAction)
        
        //finally presenting the dialog box
        self.present(alertController, animated: true, completion: nil)
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
    }


}

