//
//  ViewController.swift
//  Bsp09_Spritververbrauch
//
//  Created by User1 on 12.10.22.
//

import UIKit

class ViewController: UIViewController {
    
    // Referenzen
    @IBOutlet var tkilometer: UITextField!
    @IBOutlet var tliter: UITextField!
    @IBOutlet var tverbrauch: UITextField!
    
    @IBOutlet var bneurope: UIButton!
    
    @IBOutlet var bnusa: UIButton!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        tkilometer.text = "1200"
        tliter.text = "44"
        let defaults = UserDefaults.standard
        let km = defaults.double(forKey: "km")
        let liter = defaults.double(forKey: "liter")
        
        tkilometer.text = String(format:"%.1f",km)
        tliter.text = String(format:"%.1f",liter)

    }


    // events
    @IBAction func tkilometer_changed(_ sender: Any) {
        tverbrauch.text = "kilometer"
        checkInputs()
    }
    @IBAction func tliter_changed(_ sender: Any) {
        tverbrauch.text = "liter"
        checkInputs()
    }
    
    @IBAction func bneurope_click(_ sender: UIButton) {
        verbrauch(europaberechnung: true)

    }
    @IBAction func bnusa_click(_ sender: UIButton) {
        verbrauch(europaberechnung: false)
    }
    
    func checkInputs() {
        let liter = Double(tliter.text!)
        let kilometer = Double(tkilometer.text!)
        bneurope.isEnabled = !(liter==nil || kilometer==nil)
        bnusa.isEnabled = (liter != nil && kilometer != nil)
    }
    
    func verbrauch(europaberechnung europa:Bool) {
        let liter = Double(tliter.text!)
        let kilometer = Double(tkilometer.text!)
        var verbrauch=0
        if (liter==nil || kilometer==nil) {
            Basis.showOKDialog(parent: self, _title: "Fehler",_message: "Fehlerhafte Eingabe")
            return
        }
        // hier Berechnung
        if europa {
            let verbrauch:Double = liter!*100/kilometer!
            
            tverbrauch.text = String(format:"%.1f",verbrauch)
        }
        else {
            // 1km = 0,621371 Meilen
            // 1 Gallone = 3,78541 Liter 231 inch^3  231*2,54^3
            // 64 Meilen/Gallone
            let literProGallone = 231*(2.54*2.54*2.54)/1000.0  // 10 cm 1 dm   1liter=1 dm^3
            let verbrauchteGallonen = liter! / literProGallone  // 11,62
            
            let gefahreneMeilen = kilometer! * 0.621371
            
            let verbrauch = gefahreneMeilen / verbrauchteGallonen
            tverbrauch.text = String(format:"%.1f",verbrauch)
            
        }
        let defaults = UserDefaults.standard
        defaults.set(kilometer!,forKey: "km")
        defaults.set(liter!,forKey: "liter")

        
    }  // verbrauch
    
    
}

