//
//  ViewController.swift
//  Bsp11_TableView
//
//  Created by User1 on 19.10.22.
//

import UIKit

class ViewController: UIViewController, UITableViewDelegate, UITableViewDataSource{

    var cities: [City] = []  // ein leeres feld mit Städten
    
      
    @IBOutlet var tableview: UITableView!
    
    @IBOutlet var tResult: UITextField!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        //let city=City( Continent.AMERICA ,  "New York",  "Manhattan", Visited.NONE)
        //city.initStadt(<#T##city: City##City#>)
               
        cities = CitiesDB.loadCitiesIntern()
        cities = CitiesDB.loadCities()

        tableview.dataSource=self
        tableview.delegate=self
        
        //CitiesDB.saveCities(cities)
    }

    
    // Set the spacing between sections
     func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
       return 50  // cellSpacingHeight
     }

    //SelectecIndexChanged
     func tableView(_: UITableView, didSelectRowAt: IndexPath) {
       let row = (didSelectRowAt as NSIndexPath).row
       // Aktion
         let city = cities[row]
         tResult.text = city.name        +   "  " +     city.remark
     }
    
    // Height of the cells
      func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        switch (indexPath.row) {
          case 0:
            return 100
          case 3:
            return 80
          default:
             return UITableView.automaticDimension
        } // switch
     }
    
    
    // anzahl der Zeilen
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return cities.count
    }
    
    
    //
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell:UITableViewCell = UITableViewCell(style:UITableViewCell.CellStyle.subtitle, reuseIdentifier: "reuseIdentifier")
        
        let row = (indexPath as NSIndexPath).row
        let city:City = cities[row]
        
        cell.textLabel?.text = city.name
        cell.detailTextLabel?.text = city.remark
        
        switch (city.continent){
        case Continent.AFRICA:
            cell.imageView?.image = UIImage(named: "schwarz")
        case .AMERICA:
            cell.imageView?.image = UIImage(named: "rot")
        case .ASIA:
            cell.imageView?.image = UIImage(named: "gelb")
        case .AUSTRALIA:
            cell.imageView?.image = UIImage(named: "gruen")
        case .EUROPE:
            cell.imageView?.image = UIImage(named: "blau")
        case .ANTARKTIS:
            cell.imageView?.image = UIImage(named: "antarktis")
        default:
            cell.imageView?.image = UIImage(named: "default")
        }
        
        return cell
    }
    

}

