//
//  City.swift
//  Bsp11_TableView
//
//  Created by User1 on 19.10.22.
//

import UIKit

class City: NSObject, Comparable {
   
    static var sorttype:SortType=SortType.UNSORTED
    
     // left Hand side
    static func < (lhs: City, rhs: City) -> Bool {
        switch sorttype {
        case .UNSORTED:
            return true
        case .NAME:
            return lhs.name < rhs.name
        case .REMARK:
            return lhs.remark < rhs.remark
        case .CONTINENT:
            return lhs.continent.rawValue < rhs.continent.rawValue
        default:
            return lhs.name < rhs.name
        }
    }  // <
    
    
     
    
    var continent: Continent=Continent.AFRICA
    var name:String=""
    var remark:String=""
    var visited:Visited=Visited.NONE
    
    init(_ continent: Continent, _ name:String, _ remark:String, _ visited:Visited) {
        self.continent = continent
        self.name = name
        self.remark = remark
        self.visited = visited
    }
    
    public func initCity(_ city:City) {
        self.continent = city.continent
        self.name = city.name
        self.remark = city.remark
        self.visited = city.visited
    }
    
    
    
    public func saveCity(_ defaults:UserDefaults,_ i:Int) {
        defaults.set(self.continent.rawValue, forKey: "continent" + String(i) )
        defaults.set(self.name, forKey: "cityname" + String(i) )
        defaults.set(self.remark, forKey: "remark" + String(i) )
        defaults.set(self.visited.rawValue, forKey: "visited" + String(i) )
    }
    
    public func loadCity(_ defaults:UserDefaults,_ i:Int) {
        //self.continent =
        var rawvalue = defaults.integer(forKey: "continent" + String(i))  // 0 bis n-1 aus dem enum
        self.continent = Continent(rawValue: rawvalue) ?? Continent.AFRICA
        
        self.name = defaults.string(forKey: "cityname" + String(i))!
        self.remark = defaults.string(forKey: "remark" + String(i))!
     
        rawvalue = defaults.integer(forKey: "visited" + String(i))  // 0 bis n-1 aus dem enum
        self.visited = Visited(rawValue: rawvalue) ?? Visited.NONE
    }
    
}
