//
//  ViewController.swift
//  Bsp13_TableViewDoubleClick
//
//  Created by User1 on 30.11.22.
//

import UIKit

class ViewController: UIViewController , UITableViewDelegate, UITableViewDataSource {

    var cities: [City] = []  // ein leeres feld mit Städten
    
    // Referenzen
    @IBOutlet var tinput: UITextField!
    
    @IBOutlet var bnNew: UIButton!
    @IBOutlet var bnSort: UIButton!
    
    @IBAction func bnNew_Click(_ sender: UIButton) {
    }
    @IBOutlet var tableView: UITableView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // Change
        cities = CitiesDB.loadCities()
        if cities.isEmpty {
            print("isEmpty")
            cities = CitiesDB.loadCitiesIntern()
        }
        cities = CitiesDB.loadCitiesIntern()
        
        tableView.dataSource=self
        tableView.delegate=self
      
       
        
        bnSort.setTitle("\u{205D}", for: .normal)
        bnSort.setTitle("aaa", for: .highlighted)
        bnSort.setTitle("bbb", for: .selected)
        bnSort.setTitle("ddd", for: .focused)
       
        /*
         setTitle("Klick mich", for: UIControl.State.normal)
         setTitle("Klick mich highlighted", for: UIControl.State.highlighted)
         setTitle("Klick mich focused", for: UIControl.State.focused)
         setTitle("Klick mich selected", for: UIControl.State.selected)
         setTitle("Klick mich disabled", for: UIControl.State.disabled)
         */
        
        let menuClosure = {(action:UIAction) in
            self.updateSort(action.title)
        }
        var sortArray = [UIAction]()
        var action = UIAction(title: "Unsorted", handler: menuClosure)
        sortArray.append(action)
        
        action = UIAction(title: "Name", handler: menuClosure)
        sortArray.append(action)
        
        action = UIAction(title: "Remark", handler: menuClosure)
        sortArray.append(action)
        
        action = UIAction(title: "Continent", handler: menuClosure)
        sortArray.append(action)
        
        bnSort.menu = UIMenu(children: sortArray)
        bnSort.showsMenuAsPrimaryAction = true
        bnSort.changesSelectionAsPrimaryAction = true
        
        let tapGestureRecognizer2 = UITapGestureRecognizer(target: self, action: #selector(didTapView2(_:)))
                 tapGestureRecognizer2.numberOfTapsRequired = 2
        //tableView.addGestureRecognizer(tapGestureRecognizer2)
              
        //Long Press
       let longPressGesture = UILongPressGestureRecognizer(target: self, action: #selector(handleLongPress))
       longPressGesture.minimumPressDuration = 0.5
       self.tableView.addGestureRecognizer(longPressGesture)
   
        
    }  // viewDidLoad
    
    
    //SelectedIndexChanged:
     func tableView(_: UITableView, didSelectRowAt: IndexPath) {
         showInputViewController(ChangeMode.CHANGE)
     }
    
    
    @IBAction func didTapView2(_ sender: UITapGestureRecognizer) {
     print("doubleKlick")
       
    }
    
    
    // löschen des aktuellen Eintrags
   @objc func handleLongPress(longPressGesture: UILongPressGestureRecognizer) {
       showInputViewController(ChangeMode.DELETE)
   }
    
    
    //  CHANGE  CHANGE
    func showInputViewController(_ mode : ChangeMode ) {
        if let indexPath = tableView.indexPathForSelectedRow {
           let city:City = cities[indexPath.row]
            print("Doppel Tap: "+city.name)
            
            let storyBoard: UIStoryboard = UIStoryboard(name: "Main", bundle: nil)
            print("11")
            if let newViewController = storyBoard.instantiateViewController(withIdentifier: "InputViewControllerID") as? InputViewController {
                let city:City = cities[indexPath.row]
                newViewController.city=city
                newViewController.modus =   mode // ChangeMode.DELETE
                self.present(newViewController, animated: true, completion: nil)
            }
             
       }
        else {
            print("fehler in showInputViewController")
        }
    }
    
    func updateSort(_ title:String) {
        switch title {
        case "Unsorted":
            City.sorttype = SortType.UNSORTED
            cities = CitiesDB.loadCitiesIntern()
            tableView.reloadData()
            return
        case "Name":
            City.sorttype = SortType.NAME
        case "Remark":
            City.sorttype = SortType.REMARK
        case "Continent":
            City.sorttype = SortType.CONTINENT
        default:
            City.sorttype = SortType.NAME
        }
        cities.sort()
        tableView.reloadData()
    }
    
    

    func numberOfSections(in tableView: UITableView) -> Int {
       return 1
     }
    
    /*
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
       return 10  // cellSpacingHeight
     }
     */
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return cities.count
    }
    
    func tableView1(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell:UITableViewCell = UITableViewCell(style:UITableViewCell.CellStyle.subtitle, reuseIdentifier: "reuseIdentifier")
        
        let row = (indexPath as NSIndexPath).row
        let city:City = cities[row]
        
        cell.textLabel?.text = city.name
        cell.detailTextLabel?.text = city.remark
        
        switch (city.continent){
        case Continent.AFRICA:
            cell.imageView?.image = UIImage(named: "schwarz")
        case .AMERICA:
            cell.imageView?.image = UIImage(named: "rot")
        case .ASIA:
            cell.imageView?.image = UIImage(named: "gelb")
        case .AUSTRALIA:
            cell.imageView?.image = UIImage(named: "gruen")
        case .EUROPE:
            cell.imageView?.image = UIImage(named: "blau")
        case .ANTARKTIS:
            cell.imageView?.image = UIImage(named: "antarktis")
        default:
            cell.imageView?.image = UIImage(named: "default")
        }
        
        return cell
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "mycell", for: indexPath) as! MyCell
        
        let row = (indexPath as NSIndexPath).row
        let city:City = cities[row]
        
       
        cell.title.text = city.name
        cell.subtitle.text = city.remark
        
        switch (city.continent){
        case Continent.AFRICA:
            cell.imgcontintent.image = UIImage(named: "schwarz")
        case .AMERICA:
            cell.imgcontintent.image  = UIImage(named: "rot")
        case .ASIA:
            cell.imgcontintent.image  = UIImage(named: "gelb")
        case .AUSTRALIA:
            cell.imgcontintent.image  = UIImage(named: "gruen")
        case .EUROPE:
            cell.imgcontintent.image  = UIImage(named: "blau")
        case .ANTARKTIS:
            cell.imgcontintent.image  = UIImage(named: "antarktis")
        default:
            cell.imgcontintent.image  = UIImage(named: "default")
        }
        
        switch (city.visited) {
           case Visited.NONE:
              cell.imgvisited.image = UIImage(named: "nicht")
            case Visited.DOWN:
              cell.imgvisited.image = UIImage(named: "down")
            case Visited.AVERAGE:
              cell.imgvisited.image = UIImage(named: "haken")
            case Visited.UP:
              cell.imgvisited.image = UIImage(named: "up")
            default:
              cell.imgvisited.image = UIImage(named: "nicht")
        }
        
        return cell
    }
    
   
   
    
    
   
    
  

    
    func deleteYes() {
        //Basis.showOKDialog(parent: self, _title: "Info", _message: "deleteYes")
        if let indexPath = tableView.indexPathForSelectedRow{
            let city = cities[indexPath.row]
            cities.remove(at: indexPath.row)
            tableView.reloadData()
            CitiesDB.saveCities(cities) // change
        }
    }
                           
    func deleteNo() {
        Basis.showOKDialog(parent: self, _title: "Info", _message: "deleteNo")
    }
   
    
   
    // wenn ein 2. UIViewController aufgerufen wird, wird diese Methode VORHER aufgerufen
    // der sender ist der Schalter
    // die Variable segue  bezieht sich auf den 2. ViewController
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        
        if let button:UIButton = sender as? UIButton {
            // abfrage welcher Schalter gedrückt wurde
            if button == bnNew {
                 if let dest = segue.destination as? InputViewController {
                     dest.modus = ChangeMode.NEW
                     print("111")
                 }
            }
            else {
                Basis.showOKDialog(parent: self,_title: "Fehler",_message: "Fehlerhafte else-Bedingung in Prepare")
            }
        }
         
    }
    
    @IBAction func unwindCancel(_ segue:UIStoryboardSegue) {
        print("unwindCancel")
    }
    
    @IBAction func unwindOK(_ segue:UIStoryboardSegue) {
        print("unwind ok")
        /*
        Basis.showOKDialog(parent: self, _title: "Ok return", _message: "ww")
        print("**********************  unwindOk")
        if let src = segue.source as? EditNewViewController {
            let cityNew = src.resultCity
            print("**********************  "+cityNew.name)
            switch (src.modus) {
            case .CHANGE:
                if let indexPath = tableView.indexPathForSelectedRow{
                    let city = cities[indexPath.row]
                    city.initCity(cityNew)
                    tableView.reloadData()
                    CitiesDB.saveCities(cities) // change
                }
            case .NEW:
                let cityTable = City(Continent.AFRICA,"","",Visited.NONE)
                cityTable.initCity(cityNew)
                cities.append(cityTable)
                tableView.reloadData()
                CitiesDB.saveCities(cities) // change
            default:
                Basis.showOKDialog(parent: self,_title: "Fehler",_message: "Fehlerhafte switch-Bedingung in unwindOK")
            }
            
        }
         */
    }


}

// https://www.kodeco.com/6328155-context-menus-tutorial-for-ios-getting-started#toc-anchor-003
/*
extension ViewController: UIContextMenuInteractionDelegate {
  func contextMenuInteraction(
    _ interaction: UIContextMenuInteraction,
    configurationForMenuAtLocation location: CGPoint)
      -> UIContextMenuConfiguration? {
    return UIContextMenuConfiguration(
      identifier: nil,
      previewProvider: nil,
      actionProvider: { _ in
        let children: [UIMenuElement] = []
        return UIMenu(title: "", children: children)
    })
  }
}

*/
