//
//  ViewController.swift
//  Bsp12_TableViewEditDeleteNew
//
//  Created by User1 on 09.11.22.
//

import UIKit

class ViewController: UIViewController,  UITableViewDelegate, UITableViewDataSource {
    
   
    var cities: [City] = []  // ein leeres feld mit Städten
    
    // Referenzen
    @IBOutlet var bnEdit: UIButton!
    //@IBOutlet var bnDelete: UIButton!
    @IBOutlet var bnNew: UIButton!
    @IBOutlet var bnDelete: UIButton!
    
    @IBOutlet var tableView: UITableView!
    
    
    @IBOutlet var bnSort: UIButton!
    
    @IBOutlet var bnMenu: UIButton!
    //Action
    
    
    @IBAction func bnSort_Click(_ sender: UIButton) {
        cities.sort()  //ed(by: <#T##(City, City) throws -> Bool#>)
        
        tableView.reloadData()
    }
    
    
    
    
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // Change 
        cities = CitiesDB.loadCities()
        if cities.isEmpty {
            print("isEmpty")
            cities = CitiesDB.loadCitiesIntern()
        }
        
        tableView.dataSource=self
        tableView.delegate=self
      
        setEnabled(false)
        
        bnSort.titleLabel?.text="\u{1F496}"
        bnSort.titleLabel?.text="\u{205D}"
        bnSort.setTitle("\u{205D}", for: UIControl.State.normal)
        /*
         setTitle("Klick mich", for: UIControl.State.normal)
         setTitle("Klick mich highlighted", for: UIControl.State.highlighted)
         setTitle("Klick mich focused", for: UIControl.State.focused)
         setTitle("Klick mich selected", for: UIControl.State.selected)
         setTitle("Klick mich disabled", for: UIControl.State.disabled)
         */
        
        let menuClosure = {(action: UIAction) in
            self.updateSort(action.title)
            }
        
        var sortArray = [UIAction]()
        var action = UIAction(title: "Name", handler: menuClosure)
        sortArray.append( action )
        
        action = UIAction(title: "Remark", handler: menuClosure)
        sortArray.append( action )

        action = UIAction(title: "Kontinente", handler: menuClosure)
        sortArray.append( action )

        bnMenu.menu = UIMenu(children: sortArray)
        bnMenu.showsMenuAsPrimaryAction = true
        bnMenu.changesSelectionAsPrimaryAction = true
    }
    
    func updateSort(_ title:String) {
        switch title {
        case "Name":
            City.sorttype = SortType.NAME
        case "Remark":
            City.sorttype = SortType.REMARK
        case "Kontinente":
            City.sorttype = SortType.KONTINENTE
        default:
            City.sorttype = SortType.NAME
        }
    
        //resultCity.continent = getContinent(title)
        //bnOk.isEnabled = true
        print(title)
        cities.sort()  //ed(by: <#T##(City, City) throws -> Bool#>)
        
        tableView.reloadData()
    }
    
    func setEnabled(_ enabled:Bool){
        bnEdit.isEnabled = enabled
        bnDelete.isEnabled = enabled
        //bnNew.isEnabled = enabled
    }

    func numberOfSections(in tableView: UITableView) -> Int {
       return 1
     }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
       return 10  // cellSpacingHeight
     }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return cities.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell:UITableViewCell = UITableViewCell(style:UITableViewCell.CellStyle.subtitle, reuseIdentifier: "reuseIdentifier")
        
        let row = (indexPath as NSIndexPath).row
        let city:City = cities[row]
        
        cell.textLabel?.text = city.name
        cell.detailTextLabel?.text = city.remark
        
        switch (city.continent){
        case Continent.AFRICA:
            cell.imageView?.image = UIImage(named: "schwarz")
        case .AMERICA:
            cell.imageView?.image = UIImage(named: "rot")
        case .ASIA:
            cell.imageView?.image = UIImage(named: "gelb")
        case .AUSTRALIA:
            cell.imageView?.image = UIImage(named: "gruen")
        case .EUROPE:
            cell.imageView?.image = UIImage(named: "blau")
        case .ANTARKTIS:
            cell.imageView?.image = UIImage(named: "antarktis")
        default:
            cell.imageView?.image = UIImage(named: "default")
        }
        
        return cell
    }
    
    
    //SelectedIndexChanged
     func tableView(_: UITableView, didSelectRowAt: IndexPath) {
       let row = (didSelectRowAt as NSIndexPath).row
       // Aktion
         let city = cities[row]
         //tResult.text = city.name        +   "  " +     city.remark
         //Basis.showOKDialog(parent: self, _title: "City", _message: city.name)
         setEnabled(true)
     }
    
    
    
    func deleteYes() {
        //Basis.showOKDialog(parent: self, _title: "Info", _message: "deleteYes")
        if let indexPath = tableView.indexPathForSelectedRow{
            let city = cities[indexPath.row]
            cities.remove(at: indexPath.row)
            tableView.reloadData()
            CitiesDB.saveCities(cities) // change
        }
    }
                           
    func deleteNo() {
        Basis.showOKDialog(parent: self, _title: "Info", _message: "deleteNo")
    }
    @IBAction func bnDelete_Click(_ sender: UIButton) {
     
        if let indexPath = tableView.indexPathForSelectedRow{
            let city = cities[indexPath.row]
             let s = city.name + "  " +  city.remark
            Basis.showNoYesDialog(parent: self, _title: "Löschen einer Stadt", _message: s, _yesFunc: deleteYes, _noFunc: deleteNo)
        }
     
    }
    
   
    // wenn ein 2. UIViewController aufgerufen wird, wird diese Methode VORHER aufgerufen
    // der sender ist der Schalter
    // die Variable segue  bezieht sich auf den 2. ViewController
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if let button:UIButton = sender as? UIButton {
            // abfrage welcher Schalter gedrückt wurde
            if button == bnEdit {
                if let indexPath = tableView.indexPathForSelectedRow{
                    let city = cities[indexPath.row]
                    if let dest = segue.destination as? EditNewViewController {
                        dest.city = city
                        dest.modus = ChangeMode.CHANGE
                    }
                }
            }
            else if button == bnNew {
                 if let dest = segue.destination as? EditNewViewController {
                     dest.modus = ChangeMode.NEW
                     print("111")
                 }
            }
            else {
                Basis.showOKDialog(parent: self,_title: "Fehler",_message: "Fehlerhafte else-Bedingung in Prepare")
            }
        }
    }
    
    @IBAction func unwindCancel(_ segue:UIStoryboardSegue) {
        
    }
    
    @IBAction func unwindOK(_ segue:UIStoryboardSegue) {
        Basis.showOKDialog(parent: self, _title: "Ok return", _message: "ww")
        print("**********************  unwindOk")
        if let src = segue.source as? EditNewViewController {
            let cityNew = src.resultCity
            print("**********************  "+cityNew.name)
            switch (src.modus) {
            case .CHANGE:
                if let indexPath = tableView.indexPathForSelectedRow{
                    let city = cities[indexPath.row]
                    city.initCity(cityNew)
                    tableView.reloadData()
                    CitiesDB.saveCities(cities) // change
                }
            case .NEW:
                let cityTable = City(Continent.AFRICA,"","",Visited.NONE)
                cityTable.initCity(cityNew)
                cities.append(cityTable)
                tableView.reloadData()
                CitiesDB.saveCities(cities) // change
            default:
                Basis.showOKDialog(parent: self,_title: "Fehler",_message: "Fehlerhafte switch-Bedingung in unwindOK")
            }
            
        }
    }

}

