//
//  ViewController.swift
//  Bsp13_TableViewMyCellDoubleClick
//
//  Created by User1 on 23.11.22.
//

import UIKit

class ViewController: UIViewController,  UITableViewDelegate, UITableViewDataSource{

    var cities: [City] = []  // ein leeres feld mit Städten
    
    @IBOutlet var tableView: UITableView!
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        cities = CitiesDB.loadCities()
        if cities.isEmpty {
            print("isEmpty")
            cities = CitiesDB.loadCitiesIntern()
        }
        
        tableView.dataSource=self
        tableView.delegate=self
        
        let tapGestureRecognizer2 = UITapGestureRecognizer(target: self, action: #selector(didTapView2(_:)))
         tapGestureRecognizer2.numberOfTapsRequired = 2
        tableView.addGestureRecognizer(tapGestureRecognizer2)
    }

    func numberOfSections(in tableView: UITableView) -> Int {
       return 1
     }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
       return 10  // cellSpacingHeight
     }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return cities.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell:UITableViewCell = UITableViewCell(style:UITableViewCell.CellStyle.subtitle, reuseIdentifier: "reuseIdentifier")
        
        let row = (indexPath as NSIndexPath).row
        let city:City = cities[row]
        
        cell.textLabel?.text = city.name
        cell.detailTextLabel?.text = city.remark
        
        switch (city.continent){
        case Continent.AFRICA:
            cell.imageView?.image = UIImage(named: "schwarz")
        case .AMERICA:
            cell.imageView?.image = UIImage(named: "rot")
        case .ASIA:
            cell.imageView?.image = UIImage(named: "gelb")
        case .AUSTRALIA:
            cell.imageView?.image = UIImage(named: "gruen")
        case .EUROPE:
            cell.imageView?.image = UIImage(named: "blau")
        case .ANTARKTIS:
            cell.imageView?.image = UIImage(named: "antarktis")
        default:
            cell.imageView?.image = UIImage(named: "default")
        }
        
        return cell
    }
    
    
    //SelectedIndexChanged
     func tableView(_: UITableView, didSelectRowAt: IndexPath) {
       let row = (didSelectRowAt as NSIndexPath).row
       // Aktion
         let city = cities[row]
         //tResult.text = city.name        +   "  " +     city.remark
         //Basis.showOKDialog(parent: self, _title: "City", _message: city.name)
         //setEnabled(true)
     }
    
    // eintragen in den InputViewController
    // Mitte:  StoryBoard : InputViewControllerID
    
    // beim Kopieren die Referenzen und action löschen   !!!!!!!!!!!
    
    @IBAction func didTapView2(_ sender: UITapGestureRecognizer) {
        if let indexPath = tableView.indexPathForSelectedRow {
           let city:City = cities[indexPath.row]
            print("Doppel Tap: "+city.name)
            
            let storyBoard: UIStoryboard = UIStoryboard(name: "Main", bundle: nil)
            print("11")
            if let newViewController = storyBoard.instantiateViewController(withIdentifier: "InputViewControllerID") as? InputViewController {
                print("22")
                let city:City = cities[indexPath.row]
                print("33")
                newViewController.city=city
                print("44")
                newViewController.modus =   ChangeMode.CHANGE
                print("55")
                self.present(newViewController, animated: true, completion: nil)
                print("66")
            }
             
       }
    }
    
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
          if let button:UIButton = sender as? UIButton {
                 // Abfrage, welcher Schalter: Übergabe der Stadt
              
            
         }  // if
      }  // prepare

}


// https://www.kodeco.com/6328155-context-menus-tutorial-for-ios-getting-started#toc-anchor-003
extension ViewController: UIContextMenuInteractionDelegate {
  func contextMenuInteraction(
    _ interaction: UIContextMenuInteraction,
    configurationForMenuAtLocation location: CGPoint)
      -> UIContextMenuConfiguration? {
    return UIContextMenuConfiguration(
      identifier: nil,
      previewProvider: nil,
      actionProvider: { _ in
        let children: [UIMenuElement] = []
        return UIMenu(title: "", children: children)
    })
  }
}
